import _regeneratorRuntime from "@babel/runtime/regenerator";

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

var __awaiter = this && this.__awaiter || function (thisArg, _arguments, P, generator) {
  function adopt(value) {
    return value instanceof P ? value : new P(function (resolve) {
      resolve(value);
    });
  }

  return new (P || (P = Promise))(function (resolve, reject) {
    function fulfilled(value) {
      try {
        step(generator.next(value));
      } catch (e) {
        reject(e);
      }
    }

    function rejected(value) {
      try {
        step(generator["throw"](value));
      } catch (e) {
        reject(e);
      }
    }

    function step(result) {
      result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected);
    }

    step((generator = generator.apply(thisArg, _arguments || [])).next());
  });
};

var __rest = this && this.__rest || function (s, e) {
  var t = {};

  for (var p in s) {
    if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0) t[p] = s[p];
  }

  if (s != null && typeof Object.getOwnPropertySymbols === "function") for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
    if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i])) t[p[i]] = s[p[i]];
  }
  return t;
};

import React from 'react';

var NativeUpload =
/*#__PURE__*/
function (_React$Component) {
  _inherits(NativeUpload, _React$Component);

  function NativeUpload() {
    var _this;

    _classCallCheck(this, NativeUpload);

    _this = _possibleConstructorReturn(this, _getPrototypeOf(NativeUpload).apply(this, arguments)); // video验证
    // ratio仅支持四位小数比例的验证

    _this.varifyMedia = function (file, condition) {
      return new Promise(function (resolve) {
        var typeMatch = file.type.match(/video|image/);

        if (!typeMatch) {
          resolve(_this.validateSize(file, condition.size));
          return;
        }

        var type = typeMatch[0] === 'image' ? 'img' : typeMatch[0];
        var media = document.createElement(type);
        var mediaUrl = window.URL.createObjectURL(file);
        var isVideo = type === 'video';

        if (isVideo) {
          media.preload = 'metadata';
        }

        media.src = mediaUrl;
        var loadEvent = isVideo ? 'loadedmetadata' : 'load';
        var errorEvent = 'error';

        var mediaErrorListener = function mediaErrorListener() {
          resolve({
            success: false,
            fileName: file.name,
            errorField: typeMatch[0],
            errorMsg: "".concat(typeMatch[0].replace(/[a-z]/, function (s) {
              return s.toUpperCase();
            }), " loading failed")
          });
        };

        var mediaLoadListener = function mediaLoadListener() {
          var resolveResult = _this.getValidateResult(file, media, condition, isVideo); // 内存释放


          media.removeEventListener(loadEvent, mediaLoadListener);
          media.removeEventListener(loadEvent, mediaErrorListener);
          media = null;
          resolve(resolveResult);
        };

        media.addEventListener(loadEvent, mediaLoadListener);
        media.addEventListener(errorEvent, mediaErrorListener);
      });
    };

    _this.validateSize = function (file, maxSize) {
      var isSuccess = !maxSize || maxSize * 1024 * 1024 > file.size;

      if (!isSuccess) {
        return {
          success: false,
          fileName: file.name,
          errorMsg: "Size not more than ".concat(maxSize, "M"),
          errorField: 'size'
        };
      }

      return {
        success: true,
        fileName: file.name,
        errorMsg: '',
        errorField: ''
      };
    };

    _this.onChange = function (e) {
      return __awaiter(_assertThisInitialized(_this), void 0, void 0,
      /*#__PURE__*/
      _regeneratorRuntime.mark(function _callee() {
        var _this2 = this;

        var _this$props, beforeUpload, action, _this$props$name, name, offset, invalidHandler, fileList, fileListArray, uploadProvide, l, _loop, _ret;

        return _regeneratorRuntime.wrap(function _callee$(_context) {
          while (1) {
            switch (_context.prev = _context.next) {
              case 0:
                _this$props = this.props, beforeUpload = _this$props.beforeUpload, action = _this$props.action, _this$props$name = _this$props.name, name = _this$props$name === void 0 ? 'file' : _this$props$name, offset = _this$props.offset, invalidHandler = _this$props.invalidHandler;
                fileList = e.target.files;
                fileListArray = [].slice.call(e.target.files);
                uploadProvide = {
                  // 大小
                  withinSize: function withinSize(maxSize) {
                    return fileListArray.every(function (file) {
                      return maxSize * 1024 * 1024 > file.size;
                    });
                  },
                  // 类型
                  withinTypes: function withinTypes(types) {
                    // 用正则去匹配类型
                    var typeRegs = types.map(function (v) {
                      return new RegExp(v);
                    });
                    return fileListArray.every(function (file) {
                      return typeRegs.some(function (reg) {
                        // console.log(reg, reg.test(file.type), file.type,);
                        // mov格式其file.type类型为video/quicktime类型，外部用mov无法检测到,用quicktime代替
                        return reg.test(file.type);
                      });
                    });
                  }
                };

                if (!(beforeUpload && !beforeUpload(fileList, uploadProvide, e))) {
                  _context.next = 6;
                  break;
                }

                return _context.abrupt("return");

              case 6:
                l = fileList.length;

                _loop = function _loop() {
                  var file = fileList[l];

                  var successAction = function successAction() {
                    var formData = new FormData();
                    formData.append(name, file);
                    action(formData, file, {
                      'Content-Type': 'multipart/form-data'
                    });
                  };

                  if (!offset) {
                    successAction();
                    return {
                      v: void 0
                    };
                  }

                  _this2.varifyMedia(file, offset).then(function (ret) {
                    if (ret.success) {
                      successAction();
                      return;
                    }

                    invalidHandler && invalidHandler(ret);
                  });
                };

              case 8:
                if (!l--) {
                  _context.next = 14;
                  break;
                }

                _ret = _loop();

                if (!(_typeof(_ret) === "object")) {
                  _context.next = 12;
                  break;
                }

                return _context.abrupt("return", _ret.v);

              case 12:
                _context.next = 8;
                break;

              case 14:
              case "end":
                return _context.stop();
            }
          }
        }, _callee, this);
      }));
    };

    return _this;
  } // 验证提示信息


  _createClass(NativeUpload, [{
    key: "getValidateResult",
    value: function getValidateResult(file, media, condition, isVideo) {
      var isSuccess = true;
      var errorMsg = '';
      var errorField = '';
      var ratio = condition.ratio,
          width = condition.width,
          height = condition.height,
          size = condition.size;
      var mediaWidth = media[isVideo ? 'videoWidth' : 'width'];
      var mediaHeight = media[isVideo ? 'videoHeight' : 'height'];

      if (isSuccess && size) {
        var sizeResult = this.validateSize(file, size);
        isSuccess = sizeResult.success;
        errorMsg = sizeResult.errorMsg;
        errorField = sizeResult.errorField;
      }

      if (isSuccess && ratio) {
        isSuccess = ratio.toFixed(4) === (mediaWidth / mediaHeight).toFixed(4);

        if (!isSuccess) {
          errorMsg = "The ratio is not correct. It should be ".concat(ratio);
          errorField = 'ratio';
        }
      }

      if (isSuccess && width) {
        isSuccess = mediaWidth === width;

        if (!isSuccess) {
          errorMsg = "The width is not valid. It should be ".concat(width);
          errorField = 'width';
        }
      }

      if (isSuccess && height) {
        isSuccess = mediaHeight === height;

        if (!isSuccess) {
          errorMsg = "The height is not valid. It should be ".concat(height);
          errorField = 'height';
        }
      }

      return {
        success: isSuccess,
        fileName: file.name,
        errorField: errorField,
        errorMsg: errorMsg
      };
    }
    /**
     * 你需要用label标签，将其htmlFor属性指向这个input id;
     */

  }, {
    key: "render",
    value: function render() {
      var _a = this.props,
          disabled = _a.disabled,
          className = _a.className,
          action = _a.action,
          beforeUpload = _a.beforeUpload,
          invalidHandler = _a.invalidHandler,
          offset = _a.offset,
          rest = __rest(_a, ["disabled", "className", "action", "beforeUpload", "invalidHandler", "offset"]);

      return React.createElement("input", _extends({
        className: className,
        type: "file",
        style: {
          display: 'none'
        },
        onChange: this.onChange
      }, rest));
    }
  }]);

  return NativeUpload;
}(React.Component);

export { NativeUpload as default };
//# sourceMappingURL=index.js.map
