import React from 'react';
export interface SwiperProps {
    current: number;
    defaultCurrent?: number;
    children: Array<React.ReactElement>;
    onChange?: (current: number) => void;
    autoPlay?: boolean;
    delay?: number;
    stopOnLastSlide?: boolean;
    slideGroup?: number;
    prefixCls?: string;
    showBtn?: boolean;
    prevBtn?: React.ReactElement;
    nextBtn?: React.ReactElement;
    btnHideOnMouseOut?: boolean;
}
interface State {
    animating: boolean;
    current: number;
    renderWidth: number;
}
export default class Swiper extends React.Component<SwiperProps, State> {
    static defaultProps: Partial<SwiperProps>;
    constructor(props: SwiperProps);
    private intervalId?;
    private childWidthArr;
    private childRefsArr;
    private containerWidth;
    private resetAnimateTimer?;
    getTransform: (current: number) => React.CSSProperties;
    handleClick: (current: number, e?: React.MouseEvent<Element, MouseEvent> | undefined) => void;
    animateTick: (current?: number | undefined) => void;
    animateTickWithLimit: (current: number) => void;
    getChildWidth: () => void;
    infinitySlide: () => React.ReactElement<any, string | ((props: any) => React.ReactElement<any, string | any | (new (props: any) => React.Component<any, any, any>)> | null) | (new (props: any) => React.Component<any, any, any>)>[][];
    limitedSlide: () => React.ReactElement<any, string | ((props: any) => React.ReactElement<any, string | any | (new (props: any) => React.Component<any, any, any>)> | null) | (new (props: any) => React.Component<any, any, any>)>[];
    setAnimate: () => void;
    componentDidMount(): void;
    componentWillReceiveProps(nextProps: SwiperProps): void;
    componentDidUpdate(prevProps: SwiperProps): void;
    toPrev: (e: React.MouseEvent<Element, MouseEvent>) => void;
    toNext: (e: React.MouseEvent<Element, MouseEvent>) => void;
    componentWillUnmount(): void;
    private prevBtn;
    private nextBtn;
    render(): JSX.Element;
}
export {};
