function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

import React from 'react';
import clsx from 'clsx';
import Icon from '../icon';
import { ConfigConsumer } from '../config-provider';

var Swiper =
/*#__PURE__*/
function (_React$Component) {
  _inherits(Swiper, _React$Component);

  function Swiper(props) {
    var _this;

    _classCallCheck(this, Swiper);

    _this = _possibleConstructorReturn(this, _getPrototypeOf(Swiper).call(this, props));
    _this.childWidthArr = [];
    _this.childRefsArr = [];
    _this.containerWidth = 0;

    _this.getTransform = function (current) {
      var stopOnLastSlide = _this.props.stopOnLastSlide;
      var renderWidth = _this.state.renderWidth;

      if (renderWidth < _this.containerWidth) {
        return {
          transform: "translateX(0px)"
        };
      }

      if (!stopOnLastSlide) {
        var offset = -_this.childWidthArr.slice(0, current).reduce(function (total, _ref) {
          var width = _ref.width,
              margin = _ref.margin;
          return total + width + margin;
        }, 0);
        return {
          transform: "translateX(".concat(offset, "px)")
        };
      } else {
        var _offset = 0;

        if (current !== 0) {
          _offset = -_this.childWidthArr.slice(0, current).reduce(function (total, _ref2) {
            var width = _ref2.width,
                margin = _ref2.margin;
            return total + width + margin;
          }, 0) + _this.containerWidth / 2 - _this.childWidthArr[current].width / 2;
        }

        if (_offset > 0) {
          _offset = 0;
        } else if (renderWidth + _offset < _this.containerWidth) {
          _offset = _this.containerWidth - renderWidth;
        }

        return {
          transform: "translateX(".concat(_offset, "px)")
        };
      }
    };

    _this.handleClick = function (current, e) {
      e && e.stopPropagation();
      e && e.preventDefault();
      var stopOnLastSlide = _this.props.stopOnLastSlide;
      var animate = stopOnLastSlide ? _this.animateTickWithLimit : _this.animateTick;
      animate(current);

      _this.setAnimate();
    };

    _this.animateTick = function (current) {
      var _this$props = _this.props,
          children = _this$props.children,
          onChange = _this$props.onChange;
      var prevCurrent = _this.state.current;
      var min = children.length - 1,
          max = 2 * children.length;
      current = current || prevCurrent + 1;

      if (min < current && max > current) {
        _this.setState({
          current: current
        }, function () {
          onChange && onChange(current);
        });
      } else if (min >= current) {
        _this.setState({
          current: prevCurrent + children.length,
          animating: false
        }, function () {
          setTimeout(function () {
            _this.setState({
              current: current + children.length,
              animating: true
            }, function () {
              onChange && onChange(current);
            });
          }, 20);
        });
      } else if (max <= current) {
        _this.setState({
          current: prevCurrent - children.length,
          animating: false
        }, function () {
          setTimeout(function () {
            _this.setState({
              current: current - children.length,
              animating: true
            }, function () {
              onChange && onChange(current);
            });
          }, 20);
        });
      }
    };

    _this.animateTickWithLimit = function (current) {
      if (current > _this.props.children.length - 1) {
        clearInterval(_this.intervalId);
        return;
      }

      if (current < 0) {
        return;
      }

      var onChange = _this.props.onChange;

      _this.setState({
        current: current
      }, function () {
        onChange && onChange(current);
      });
    };

    _this.getChildWidth = function () {
      _this.childWidthArr = Array.from(_this.childRefsArr, function (el) {
        var currentTargetEl = el.current;

        if (currentTargetEl) {
          var targetStyle = window.getComputedStyle(currentTargetEl);
          return {
            width: currentTargetEl.clientWidth,
            margin: parseInt(targetStyle.marginRight)
          };
        }

        return {
          width: 0,
          margin: 0
        };
      });

      _this.setState({
        renderWidth: _this.childWidthArr.reduce(function (total, _ref3) {
          var width = _ref3.width,
              margin = _ref3.margin;
          return total + width + margin;
        }, 0)
      });
    };

    _this.infinitySlide = function () {
      var children = _this.props.children;
      return Array.from(new Array(3), function (_el, index) {
        return React.Children.map(children, function (element, childIndex) {
          var ref = React.createRef();
          _this.childRefsArr[index * children.length + childIndex] = ref;
          return React.cloneElement(element, {
            ref: ref,
            onClick: function onClick(e) {
              return _this.handleClick(index * children.length + childIndex, e);
            }
          });
        });
      });
    };

    _this.limitedSlide = function () {
      var children = _this.props.children;
      return React.Children.map(children, function (element, childIndex) {
        var ref = React.createRef();
        _this.childRefsArr[childIndex] = ref;
        return React.cloneElement(element, {
          ref: ref,
          onClick: function onClick(e) {
            return _this.handleClick(childIndex, e);
          }
        });
      });
    };

    _this.setAnimate = function () {
      if (_this.props.autoPlay) {
        var _this$props2 = _this.props,
            delay = _this$props2.delay,
            stopOnLastSlide = _this$props2.stopOnLastSlide;
        var animate = stopOnLastSlide ? _this.animateTickWithLimit : _this.animateTick;

        if (_this.intervalId) {
          clearInterval(_this.intervalId);
        }

        if (_this.resetAnimateTimer) {
          clearTimeout(_this.resetAnimateTimer);
        }

        _this.resetAnimateTimer = window.setTimeout(function () {
          return _this.intervalId = window.setInterval(function () {
            return animate(_this.state.current + 1);
          }, delay);
        }, delay);
      }
    };

    _this.toPrev = function (e) {
      e.stopPropagation();

      _this.handleClick(_this.state.current - _this.props.slideGroup);
    };

    _this.toNext = function (e) {
      e.stopPropagation();

      _this.handleClick(_this.state.current + _this.props.slideGroup);
    };

    _this.prevBtn = function (prefixCls) {
      var prevBtn = _this.props.prevBtn;

      if (prevBtn) {
        return React.cloneElement(prevBtn, {
          className: "".concat(prefixCls, "-leftArrow ").concat(prevBtn.props.className),
          onClick: function onClick(e) {
            return _this.toPrev(e);
          }
        });
      } else {
        return React.createElement("span", {
          className: "".concat(prefixCls, "-leftArrow"),
          onClick: function onClick(e) {
            return _this.toPrev(e);
          }
        }, React.createElement(Icon, {
          type: "left"
        }));
      }
    };

    _this.nextBtn = function (prefixCls) {
      var nextBtn = _this.props.nextBtn;

      if (nextBtn) {
        return React.cloneElement(nextBtn, {
          className: "".concat(prefixCls, "-rightArrow ").concat(nextBtn.props.className),
          onClick: function onClick(e) {
            return _this.toNext(e);
          }
        });
      } else {
        return React.createElement("span", {
          className: "".concat(prefixCls, "-rightArrow"),
          onClick: function onClick(e) {
            return _this.toNext(e);
          }
        }, React.createElement(Icon, {
          type: "right"
        }));
      }
    };

    _this.state = {
      animating: true,
      current: props.stopOnLastSlide ? props.current : props.current + props.children.length,
      renderWidth: 0
    };
    return _this;
  }

  _createClass(Swiper, [{
    key: "componentDidMount",
    value: function componentDidMount() {
      var _this2 = this;

      this.setAnimate();
      this.getChildWidth();
      this.setState({
        current: this.state.current,
        animating: false
      }, function () {
        setTimeout(function () {
          _this2.setState({
            animating: true
          });
        }, 20);
      });
    }
  }, {
    key: "componentWillReceiveProps",
    value: function componentWillReceiveProps(nextProps) {
      if (this.state.current !== nextProps.current) {
        this.setState({
          current: nextProps.current
        });
      }
    }
  }, {
    key: "componentDidUpdate",
    value: function componentDidUpdate(prevProps) {
      if (prevProps.children !== this.props.children) {
        this.getChildWidth();
      }
    }
  }, {
    key: "componentWillUnmount",
    value: function componentWillUnmount() {
      clearInterval(this.intervalId);
    }
  }, {
    key: "render",
    value: function render() {
      var _this3 = this;

      var _this$props3 = this.props,
          stopOnLastSlide = _this$props3.stopOnLastSlide,
          customizePrefixCls = _this$props3.prefixCls,
          showBtn = _this$props3.showBtn,
          btnHideOnMouseOut = _this$props3.btnHideOnMouseOut;
      var _this$state = this.state,
          animating = _this$state.animating,
          current = _this$state.current;
      var transformStyle = this.getTransform(current);
      return React.createElement(ConfigConsumer, null, function (_ref4) {
        var getPrefixCls = _ref4.getPrefixCls;
        var prefixCls = getPrefixCls('swiper', customizePrefixCls);
        return React.createElement("div", {
          className: "".concat(prefixCls, "-swiperMask ").concat(btnHideOnMouseOut ? prefixCls + '-swiperMask-btn-will-hide' : ''),
          ref: function ref(_ref5) {
            var _a;

            return _this3.containerWidth = ((_a = _ref5) === null || _a === void 0 ? void 0 : _a.clientWidth) || 0;
          }
        }, showBtn && _this3.prevBtn(prefixCls), React.createElement("div", {
          className: "".concat(prefixCls, "-swiperContent")
        }, React.createElement("div", {
          className: clsx("".concat(prefixCls, "-swiperContainer"), animating ? "".concat(prefixCls, "-isTransition") : ''),
          style: transformStyle
        }, stopOnLastSlide ? _this3.limitedSlide() : _this3.infinitySlide())), showBtn && _this3.nextBtn(prefixCls));
      });
    }
  }]);

  return Swiper;
}(React.Component);

export { Swiper as default };
Swiper.defaultProps = {
  current: 0,
  defaultCurrent: 0,
  // direction: 'RIGHT',
  delay: 2000,
  autoPlay: false,
  stopOnLastSlide: true,
  slideGroup: 1,
  prefixCls: 'palmax-swiper',
  showBtn: true
};
//# sourceMappingURL=index.js.map
