import React from 'react';
export interface TablePaginationProps {
    total?: number;
    defaultCurrent?: number;
    disabled?: boolean;
    current?: number;
    defaultPageSize?: number;
    pageSize?: number;
    onChange?: (page: number, pageSize?: number) => void;
    hideOnSinglePage?: boolean;
    style?: React.CSSProperties;
    className?: string;
    prefixCls?: string;
    prevIcon?: React.ReactElement<HTMLElement>;
    nextIcon?: React.ReactElement<HTMLElement>;
    jumpFirstIcon?: React.ReactElement<HTMLElement>;
    jumpLastIcon?: React.ReactElement<HTMLElement>;
}
export interface State {
    current: number;
}
declare class TablePagination extends React.Component<TablePaginationProps, State> {
    static defaultProps: {
        defaultCurrent: number;
        total: number;
        pageSize: number;
        onChange: () => void;
        className: string;
        prefixCls: string;
        hideOnSinglePage: boolean;
        style: {};
    };
    constructor(props: TablePaginationProps);
    isValid: (page: React.ReactText) => boolean;
    getItemIcon: (icon: React.ReactElement<HTMLElement, string | ((props: any) => React.ReactElement<any, string | any | (new (props: any) => React.Component<any, any, any>)> | null) | (new (props: any) => React.Component<any, any, any>)> | (() => React.ReactElement<HTMLElement, string | ((props: any) => React.ReactElement<any, string | any | (new (props: any) => React.Component<any, any, any>)> | null) | (new (props: any) => React.Component<any, any, any>)>)) => React.ReactElement<HTMLElement, string | ((props: any) => React.ReactElement<any, string | any | (new (props: any) => React.Component<any, any, any>)> | null) | (new (props: any) => React.Component<any, any, any>)> | (() => React.ReactElement<HTMLElement, string | ((props: any) => React.ReactElement<any, string | any | (new (props: any) => React.Component<any, any, any>)> | null) | (new (props: any) => React.Component<any, any, any>)>);
    prev: () => void;
    next: () => void;
    hasPrev: () => boolean;
    hasNext: () => boolean;
    jumpFirst: () => void;
    jumpLast: () => void;
    runIfEnter: (event: React.KeyboardEvent<HTMLLIElement>, callback: (params?: any) => void) => void;
    runIfEnterPrev: (e: React.KeyboardEvent<HTMLLIElement>) => void;
    runIfEnterNext: (e: React.KeyboardEvent<HTMLLIElement>) => void;
    runIfEnterJumpFirst: (e: React.KeyboardEvent<HTMLLIElement>) => void;
    runIfEnterJumpLast: (e: React.KeyboardEvent<HTMLLIElement>) => void;
    handleChange: (p: number) => number;
    renderBtns: (prefixCls: string) => JSX.Element;
    getShowItemNumber: () => string;
    componentWillReceiveProps(nextProps: TablePaginationProps): void;
    render(): JSX.Element | null;
}
export default TablePagination;
