"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _react = _interopRequireDefault(require("react"));

var _icon = _interopRequireDefault(require("../icon"));

var _configProvider = require("../config-provider");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

var noop = function noop() {};

var calculatePage = function calculatePage(p, total) {
  return Math.floor((total - 1) / p) + 1;
};

var isInteger = function isInteger(value) {
  return typeof value === 'number' && isFinite(value) && Math.floor(value) === value;
};

var TablePagination =
/*#__PURE__*/
function (_React$Component) {
  _inherits(TablePagination, _React$Component);

  function TablePagination(props) {
    var _this;

    _classCallCheck(this, TablePagination);

    _this = _possibleConstructorReturn(this, _getPrototypeOf(TablePagination).call(this, props));

    _this.isValid = function (page) {
      return isInteger(page) && page !== _this.state.current;
    };

    _this.getItemIcon = function (icon) {
      var prefixCls = _this.props.prefixCls;

      var iconNode = icon || _react["default"].createElement("a", {
        className: "".concat(prefixCls, "-item-link")
      });

      if (typeof icon === 'function') {
        iconNode = icon();
      }

      return iconNode;
    };

    _this.prev = function () {
      if (_this.hasPrev()) {
        _this.handleChange(_this.state.current - 1);
      }
    };

    _this.next = function () {
      if (_this.hasNext()) {
        _this.handleChange(_this.state.current + 1);
      }
    };

    _this.hasPrev = function () {
      return _this.state.current > 1;
    };

    _this.hasNext = function () {
      var _this$props = _this.props,
          pageSize = _this$props.pageSize,
          total = _this$props.total;
      return _this.state.current < calculatePage(pageSize, total);
    };

    _this.jumpFirst = function () {
      _this.handleChange(1);
    };

    _this.jumpLast = function () {
      var _this$props2 = _this.props,
          pageSize = _this$props2.pageSize,
          total = _this$props2.total;

      _this.handleChange(calculatePage(pageSize, total));
    };

    _this.runIfEnter = function (event, callback) {
      if (event.key === 'Enter' || event.charCode === 13) {
        callback();
      }
    };

    _this.runIfEnterPrev = function (e) {
      _this.runIfEnter(e, _this.prev);
    };

    _this.runIfEnterNext = function (e) {
      _this.runIfEnter(e, _this.next);
    };

    _this.runIfEnterJumpFirst = function (e) {
      _this.runIfEnter(e, _this.jumpFirst);
    };

    _this.runIfEnterJumpLast = function (e) {
      _this.runIfEnter(e, _this.jumpLast);
    };

    _this.handleChange = function (p) {
      var _this$props3 = _this.props,
          disabled = _this$props3.disabled,
          pageSize = _this$props3.pageSize,
          total = _this$props3.total,
          onChange = _this$props3.onChange;
      var page = p;

      if (_this.isValid(page) && !disabled) {
        var currentPage = calculatePage(pageSize, total);

        if (page > currentPage) {
          page = currentPage;
        } else if (page < 1) {
          page = 1;
        }

        _this.setState({
          current: page
        });

        onChange && onChange(page, pageSize);
        return page;
      }

      return _this.state.current;
    };

    _this.renderBtns = function (prefixCls) {
      var prevIcon = _this.props.prevIcon ? _this.getItemIcon(_this.props.prevIcon) : _react["default"].createElement("a", {
        className: "".concat(prefixCls, "-item-link")
      }, _react["default"].createElement(_icon["default"], {
        type: "left"
      }));
      var nextIcon = _this.props.nextIcon ? _this.getItemIcon(_this.props.nextIcon) : _react["default"].createElement("a", {
        className: "".concat(prefixCls, "-item-link")
      }, _react["default"].createElement(_icon["default"], {
        type: "right"
      }));
      var jumpFirstIcon = _this.props.jumpFirstIcon ? _this.getItemIcon(_this.props.jumpFirstIcon) : _react["default"].createElement("a", {
        className: "".concat(prefixCls, "-item-link")
      }, _react["default"].createElement(_icon["default"], {
        className: "".concat(prefixCls, "-item-link-icon"),
        type: "double-left"
      }));
      var jumpLastIcon = _this.props.jumpLastIcon ? _this.getItemIcon(_this.props.jumpLastIcon) : _react["default"].createElement("a", {
        className: "".concat(prefixCls, "-item-link")
      }, _react["default"].createElement(_icon["default"], {
        className: "".concat(prefixCls, "-item-link-icon"),
        type: "double-right"
      }));
      return _react["default"].createElement("ul", {
        className: "".concat(prefixCls, "-btn-list ").concat(_this.props.className)
      }, _react["default"].createElement("li", {
        onClick: _this.jumpFirst,
        tabIndex: _this.hasPrev() ? 0 : undefined,
        onKeyPress: _this.runIfEnterJumpFirst,
        className: "".concat(_this.hasPrev() ? '' : "".concat(prefixCls, "-disabled"), " ").concat(prefixCls, "-first"),
        "aria-disabled": !_this.hasPrev()
      }, jumpFirstIcon), _react["default"].createElement("li", {
        onClick: _this.prev,
        tabIndex: _this.hasPrev() ? 0 : undefined,
        onKeyPress: _this.runIfEnterPrev,
        className: "".concat(_this.hasPrev() ? '' : "".concat(prefixCls, "-disabled"), " ").concat(prefixCls, "-prev"),
        "aria-disabled": !_this.hasPrev()
      }, prevIcon), _react["default"].createElement("li", {
        onClick: _this.next,
        tabIndex: _this.hasNext() ? 0 : undefined,
        onKeyPress: _this.runIfEnterNext,
        className: "".concat(_this.hasNext() ? '' : "".concat(prefixCls, "-disabled"), " ").concat(prefixCls, "-next"),
        "aria-disabled": !_this.hasNext()
      }, nextIcon), _react["default"].createElement("li", {
        onClick: _this.jumpLast,
        tabIndex: _this.hasNext() ? 0 : undefined,
        onKeyPress: _this.runIfEnterJumpLast,
        className: "".concat(_this.hasNext() ? '' : "".concat(prefixCls, "-disabled"), " ").concat(prefixCls, "-last"),
        "aria-disabled": !_this.hasNext()
      }, jumpLastIcon));
    };

    _this.getShowItemNumber = function () {
      var _this$props4 = _this.props,
          total = _this$props4.total,
          pageSize = _this$props4.pageSize;
      var current = _this.state.current;
      var baseNumber = pageSize * (current - 1);
      var _ref = [Math.min(baseNumber + 1, total), Math.min(baseNumber + pageSize, total)],
          minNumber = _ref[0],
          maxNumber = _ref[1];
      return "".concat(minNumber, " - ").concat(maxNumber);
    };

    var current = props.current || props.defaultCurrent;
    _this.state = {
      current: current
    };
    return _this;
  }

  _createClass(TablePagination, [{
    key: "componentWillReceiveProps",
    value: function componentWillReceiveProps(nextProps) {
      console.log(nextProps.current, this.state.current);

      if (nextProps.current && this.state.current !== nextProps.current) {
        this.setState({
          current: nextProps.current
        });
      }
    }
  }, {
    key: "render",
    value: function render() {
      var _this2 = this;

      var _this$props5 = this.props,
          customizePrefixCls = _this$props5.prefixCls,
          className = _this$props5.className,
          total = _this$props5.total,
          hideOnSinglePage = _this$props5.hideOnSinglePage,
          pageSize = _this$props5.pageSize;

      if (hideOnSinglePage === true && total <= pageSize) {
        return null;
      }

      return _react["default"].createElement(_configProvider.ConfigConsumer, null, function (_ref2) {
        var getPrefixCls = _ref2.getPrefixCls;
        var prefixCls = getPrefixCls('table-pagination', customizePrefixCls);
        return _react["default"].createElement("div", {
          className: "".concat(prefixCls, " ").concat(prefixCls, "-container ").concat(className)
        }, _react["default"].createElement("p", {
          className: "".concat(prefixCls, "-total")
        }, _this2.getShowItemNumber(), " of ", total), _this2.renderBtns(prefixCls));
      });
    }
  }]);

  return TablePagination;
}(_react["default"].Component);

TablePagination.defaultProps = {
  defaultCurrent: 1,
  total: 55,
  pageSize: 10,
  onChange: noop,
  className: '',
  prefixCls: 'palmax-table-pagination',
  hideOnSinglePage: false,
  style: {}
};
var _default = TablePagination;
exports["default"] = _default;
//# sourceMappingURL=TablePagination.js.map
